package com.antoniofrische.perifericosAdvisor.service;

import java.util.Collection;
import java.util.List;
import java.util.stream.Collectors;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import com.antoniofrische.perifericosAdvisor.dao.PerifericoDao;
import com.antoniofrische.perifericosAdvisor.model.Periferico;

@Service
public class PerifericoService {

	@Autowired
	PerifericoDao perifericoDao;

	@Autowired
	PerifericoQueryService queryService;

	public Collection<String> findAllTipo() {
		List<String> result = null;

		// @formatter:off
		result = (List<String>) perifericoDao.findAll()
				.stream()
				.map(p -> p.getTipo())
				.flatMap(lista -> lista.stream()
				.distinct()
				.sorted()
				.collect(Collectors.toList()));
		// @formatter:on

		return result;
	}

	public Collection<Periferico> findByAnyTipo(String... tipo) {

		return queryService.anyTipo(tipo).exec();

	}

	public Collection<Periferico> findByAllTipo(String... tipo) {
		return queryService.allTipo(tipo).exec();
	}

	public Collection<Periferico> findByColor(String color) {
		return queryService.color(color).exec();
	}


	public Collection<Periferico> findByTitleContains(String nombre) {
		return queryService.titleContains(nombre).exec();
	}

	public Collection<Periferico> findAll() {
		return perifericoDao.findAll();
	}
}
